#include "config.h"

#include <stdio.h>
#include <stdlib.h>

#ifdef USE_NLLIBC
#include <nllibc.h>
#endif

#include "const.h"
#include "image.h"
#include "charset.h"

extern unsigned char charset_character_2_bitmap[];

struct charset charset_character_2 = {
  32, 32, 5, { NULL, charset_character_2_bitmap },
  IMAGE_TYPE_ROUGHCOLOR, IMAGE_FLAG_STATIC
};

#define TP 0x80 /* transparent */

#define B_   (1 << 0)
#define B__  (2 << 0)
#define B___ (3 << 0)
#define G_   (1 << 2)
#define G__  (2 << 2)
#define G___ (3 << 2)
#define R_   (1 << 4)
#define R__  (2 << 4)
#define R___ (3 << 4)

#define BK 0x00 /* black */

#define BL (          B___) /* blue */
#define GR (     G___     ) /* green */
#define CY (     G___|B___) /* cyan */
#define RD (R___          ) /* red */
#define MG (R___     |B___) /* magenta */
#define YL (R___|G___     ) /* yellow */
#define WH (R___|G___|B___) /* white */

#define B0 (        B_ )
#define B1 (        B__)
#define G0 (    G_     )
#define G1 (    G__    )
#define C0 (    G_ |B_ )
#define C1 (    G__|B__)
#define R0 (R_         )
#define R1 (R__        )
#define M0 (R_     |B_ )
#define M1 (R__    |B__)
#define Y0 (R_ |G_     )
#define Y1 (R__|G__    )
#define W0 (R_ |G_ |B_ )
#define W1 (R__|G__|B__)

#define C2 (     G_  |B__ )
#define C3 (     G_  |B___)
#define C4 (     G__ |B_  )
#define C5 (     G__ |B___)
#define C6 (     G___|B_  )
#define C7 (     G___|B__ )
#define M2 (R_       |B__ )
#define M3 (R_       |B___)
#define M4 (R__      |B_  )
#define M5 (R__      |B___)
#define M6 (R___     |B_  )
#define M7 (R___     |B__ )
#define Y2 (R_  |G__      )
#define Y3 (R_  |G___     )
#define Y4 (R__ |G_       )
#define Y5 (R__ |G___     )
#define Y6 (R___|G_       )
#define Y7 (R___|G__      )

#define PK (R___|G_  |B_  ) /* pink */
#define BR (R_            ) /* brown */
#define OR (R___|G_       ) /* orange */
#define SK (R___|G__ |B__ ) /* skin */
#define BM (R__      |B___) /* blue magenta */
#define LG (R_  |G___     ) /* light green */

unsigned char charset_character_2_bitmap[] = {
  /* apple */
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,BR,GR,GR,GR,GR,GR,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,BR,GR,GR,GR,GR,GR,GR,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,BR,BR,GR,GR,GR,GR,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,RD,RD,RD,RD,RD,RD,TP,TP,BR,TP,TP,TP,RD,RD,RD,RD,RD,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,BR,BR,BR,RD,RD,RD,RD,RD,RD,RD,RD,RD,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,TP,TP,TP,TP,
  TP,TP,TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,TP,TP,TP,TP,
  TP,TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,TP,TP,TP,
  TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,TP,TP,
  TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,TP,TP,
  TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,TP,TP,
  TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,TP,TP,
  TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,TP,TP,
  TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,TP,TP,
  TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,TP,TP,
  TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,WH,WH,RD,TP,TP,
  TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,WH,WH,RD,TP,TP,
  TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,TP,TP,
  TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,WH,RD,TP,TP,
  TP,TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,WH,RD,TP,TP,
  TP,TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,WH,WH,RD,TP,TP,
  TP,TP,TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,WH,WH,WH,TP,TP,TP,
  TP,TP,TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,WH,WH,WH,RD,TP,TP,TP,
  TP,TP,TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,WH,WH,WH,RD,TP,TP,TP,TP,
  TP,TP,TP,TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,WH,WH,RD,RD,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,WH,WH,RD,RD,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,WH,WH,RD,RD,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,

  /* grape */
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,BR,BR,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,BR,BR,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,BR,BR,BR,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,MG,TP,TP,MG,MG,MG,MG,MG,MG,MG,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,M1,MG,MG,MG,M1,MG,MG,WH,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,M1,MG,MG,MG,MG,MG,MG,WH,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,M1,MG,MG,MG,MG,MG,MG,WH,MG,MG,WH,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,M1,MG,M1,M1,MG,MG,M1,MG,MG,MG,M1,MG,MG,MG,MG,MG,MG,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,M1,MG,MG,MG,MG,MG,MG,MG,M1,MG,MG,MG,MG,WH,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,WH,MG,MG,MG,MG,MG,WH,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,M1,MG,WH,MG,MG,MG,WH,MG,MG,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,M1,MG,WH,MG,WH,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,MG,M1,MG,MG,MG,MG,MG,MG,MG,MG,MG,WH,MG,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,MG,MG,MG,M1,MG,MG,MG,M1,M1,MG,MG,MG,MG,MG,WH,WH,MG,WH,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,M1,MG,MG,MG,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,M1,MG,WH,MG,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,MG,MG,MG,WH,WH,MG,MG,WH,MG,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,MG,MG,MG,WH,MG,MG,WH,WH,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,MG,MG,MG,MG,WH,MG,MG,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,MG,MG,MG,WH,WH,MG,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,MG,MG,MG,MG,MG,MG,WH,WH,WH,WH,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,MG,MG,MG,WH,MG,MG,MG,MG,MG,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,MG,WH,MG,MG,WH,WH,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,MG,MG,WH,MG,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,WH,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,

  /* watermelon */
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,GR,LG,WH,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,LG,GR,TP,TP,
  TP,GR,LG,WH,RD,RD,RD,RD,RD,RD,BK,BK,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,BK,RD,RD,RD,WH,GR,TP,TP,
  TP,GR,LG,WH,RD,YL,RD,BK,RD,RD,RD,RD,YL,RD,RD,RD,RD,RD,RD,YL,YL,RD,RD,RD,BK,RD,RD,RD,WH,GR,TP,TP,
  TP,BK,LG,WH,RD,RD,RD,BK,RD,RD,RD,RD,RD,RD,RD,RD,BK,RD,RD,RD,RD,BK,RD,RD,RD,RD,RD,WH,LG,GR,TP,TP,
  TP,GR,LG,WH,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,BK,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,WH,LG,GR,TP,TP,
  TP,TP,LG,WH,RD,RD,RD,RD,RD,RD,RD,RD,BK,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,YL,RD,RD,YL,LG,LG,GR,TP,TP,
  TP,TP,LG,WH,RD,RD,YL,YL,RD,RD,RD,RD,BK,RD,RD,YL,RD,RD,RD,RD,RD,RD,RD,YL,YL,RD,WH,LG,LG,GR,TP,TP,
  TP,TP,BK,LG,YL,RD,YL,YL,RD,BK,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,BK,RD,RD,RD,YL,WH,LG,GR,TP,TP,TP,
  TP,TP,GR,LG,WH,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,WH,LG,LG,GR,TP,TP,TP,
  TP,TP,TP,GR,LG,YL,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,BK,BK,RD,RD,RD,RD,RD,RD,WH,LG,LG,GR,TP,TP,TP,TP,
  TP,TP,TP,TP,GR,LG,WH,RD,RD,RD,YL,RD,BK,RD,RD,RD,BK,BK,RD,RD,RD,RD,RD,RD,WH,LG,LG,GR,TP,TP,TP,TP,
  TP,TP,TP,TP,BK,LG,LG,WH,RD,RD,YL,RD,BK,RD,RD,RD,RD,RD,RD,YL,YL,BK,RD,WH,LG,LG,BK,BK,TP,TP,TP,TP,
  TP,TP,TP,TP,BK,GR,GR,LG,WH,RD,RD,RD,RD,RD,RD,RD,RD,RD,RD,YL,YL,BK,WH,LG,LG,GR,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,GR,LG,LG,WH,WH,WH,WH,YL,YL,YL,YL,YL,YL,WH,WH,LG,LG,GR,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,GR,LG,LG,LG,LG,LG,LG,LG,WH,WH,LG,LG,LG,LG,LG,GR,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,GR,GR,BK,GR,GR,GR,BK,GR,GR,GR,GR,BK,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,

  /* peach */
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,PK,PK,PK,PK,PK,PK,PK,PK,PK,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,OR,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,TP,TP,TP,TP,
  TP,TP,TP,TP,OR,OR,OR,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,TP,TP,TP,
  TP,TP,TP,TP,OR,OR,OR,OR,OR,OR,PK,PK,PK,PK,OR,OR,OR,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,PK,TP,TP,
  TP,TP,TP,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,TP,TP,
  TP,TP,TP,YL,YL,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,OR,TP,
  TP,TP,TP,YL,YL,YL,YL,OR,YL,YL,YL,YL,YL,YL,YL,OR,OR,YL,YL,OR,OR,OR,OR,OR,YL,YL,OR,OR,YL,YL,YL,TP,
  TP,TP,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,LG,
  TP,TP,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,LG,LG,
  TP,TP,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,LG,LG,LG,
  TP,TP,LG,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,LG,LG,LG,LG,
  TP,LG,LG,LG,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,LG,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,YL,LG,LG,LG,LG,LG,
  LG,LG,LG,LG,LG,YL,YL,YL,YL,YL,YL,YL,LG,LG,LG,LG,YL,YL,YL,YL,YL,YL,YL,YL,YL,LG,LG,LG,LG,LG,LG,LG,
  LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,TP,TP,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,
  LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,TP,TP,TP,TP,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,
  TP,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,TP,TP,TP,TP,TP,TP,TP,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,
  TP,TP,LG,LG,LG,LG,LG,LG,LG,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,LG,LG,LG,LG,LG,LG,LG,LG,LG,LG,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,

  /* banana */
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,BR,BR,BR,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,BR,BR,BR,BR,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,Y0,Y0,Y0,Y0,BR,BR,Y1,BR,BR,BR,BR,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,Y0,Y0,Y0,Y0,Y1,Y1,Y1,BR,BR,YL,YL,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,Y0,Y0,Y0,Y0,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,Y0,Y0,Y0,Y0,Y0,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,Y0,Y0,Y0,Y0,Y0,Y1,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,Y0,Y0,Y0,Y0,Y0,Y0,Y1,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y1,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,YL,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y1,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,YL,YL,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y1,Y1,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,YL,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y1,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,YL,YL,YL,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y1,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,YL,YL,YL,YL,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y1,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,YL,YL,YL,YL,TP,TP,
  TP,TP,TP,TP,TP,TP,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y1,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,YL,YL,YL,TP,TP,TP,
  TP,TP,TP,TP,TP,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y1,Y1,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,YL,YL,YL,TP,TP,TP,
  TP,TP,TP,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y1,Y1,Y1,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,YL,YL,YL,TP,TP,TP,
  TP,TP,TP,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y1,Y1,Y1,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,YL,YL,YL,YL,TP,TP,TP,
  TP,TP,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y1,Y1,Y1,Y1,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,YL,YL,YL,YL,TP,TP,TP,
  TP,TP,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y1,Y1,Y1,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,YL,YL,YL,YL,YL,TP,TP,TP,
  TP,TP,TP,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y0,Y1,Y1,Y1,Y1,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,YL,YL,YL,YL,TP,TP,TP,TP,
  TP,TP,TP,Y0,Y0,Y0,Y0,Y0,Y0,TP,Y1,Y1,Y1,Y1,Y1,Y1,Y1,Y1,Y1,YL,YL,YL,YL,YL,YL,YL,YL,YL,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,Y0,Y0,Y0,TP,TP,Y1,Y1,Y1,Y1,Y1,Y1,Y1,Y1,TP,TP,YL,YL,YL,YL,YL,YL,YL,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,Y1,Y1,Y1,Y1,Y1,Y1,Y1,TP,TP,TP,TP,YL,YL,YL,YL,YL,YL,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,Y1,Y1,Y1,Y1,Y1,Y1,TP,TP,TP,TP,TP,TP,YL,YL,YL,YL,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,Y1,Y1,Y1,Y1,TP,TP,TP,TP,TP,TP,TP,TP,YL,YL,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
  TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,TP,
};
