#include "config.h"

#include <stdio.h>
#include <stdlib.h>

#ifdef USE_NLLIBC
#include <nllibc.h>
#endif

#include "const.h"
#include "image.h"
#include "charset.h"

extern unsigned char charset_character_bitmap[];

struct charset charset_character = {
  64, 64, 10, { NULL, charset_character_bitmap },
  IMAGE_TYPE_ROUGHCOLOR, IMAGE_FLAG_STATIC
};

#define T 0x80 /* transparent */

#define B_   (1 << 0)
#define B__  (2 << 0)
#define B___ (3 << 0)
#define G_   (1 << 2)
#define G__  (2 << 2)
#define G___ (3 << 2)
#define R_   (1 << 4)
#define R__  (2 << 4)
#define R___ (3 << 4)

#define N 0x00 /* black */

#define B (          B___) /* blue */
#define G (     G___     ) /* green */
#define C (     G___|B___) /* cyan */
#define R (R___          ) /* red */
#define M (R___     |B___) /* magenta */
#define Y (R___|G___     ) /* yellow */
#define W (R___|G___|B___) /* white */

#define P (R___|G_  |B_  ) /* pink */
#define D (R_            ) /* brown */
#define O (R___|G_       ) /* orange */
#define S (R___|G__ |B__ ) /* skin */

unsigned char charset_character_bitmap[] = {
  /* nijimasu-kun */
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,T,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,W,W,W,W,W,R,R,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,
  T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,
  T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,R,R,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,
  T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,R,R,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,
  T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,R,W,W,W,W,W,W,W,R,R,W,W,W,W,W,W,W,R,R,R,R,R,R,
  T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,R,R,W,W,W,W,R,R,R,R,R,R,R,
  T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,R,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,R,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,R,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,

  /* nijimasu-kun-huu */
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,T,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,
  T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,
  T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,R,R,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,
  T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,R,R,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,
  T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,R,W,W,W,W,W,W,W,R,R,W,W,W,W,W,W,W,R,R,R,R,R,R,
  T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,R,R,W,W,W,W,R,R,R,R,R,R,R,
  T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,R,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,R,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,R,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,

  /* nijimasu-kun-x */
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,T,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,W,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,W,W,W,W,W,W,W,R,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,
  T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,
  T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,R,R,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,
  T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,R,R,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,
  T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,R,W,W,W,W,W,W,W,R,R,W,W,W,W,W,W,W,R,R,R,R,R,R,
  T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,R,R,W,W,W,W,R,R,R,R,R,R,R,
  T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,R,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,R,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,R,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,

  /* nijimasu-kun-pun */
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,T,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,R,R,R,R,R,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,W,W,W,W,R,R,R,R,R,R,R,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,W,R,R,W,R,R,R,R,R,R,R,R,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,R,W,W,W,R,R,W,R,R,R,R,R,R,R,R,R,R,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,R,R,R,R,W,W,W,W,W,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,R,R,W,W,W,W,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,R,W,W,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,R,W,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,R,W,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,
  T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,
  T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,R,R,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,
  T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,W,R,R,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,
  T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,R,W,W,W,W,W,W,W,R,R,W,W,W,W,W,W,W,R,R,R,R,R,R,
  T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,R,R,W,W,W,W,R,R,R,R,R,R,R,
  T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,R,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,R,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,R,R,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,W,W,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,

  /* nlkun */
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,T,T,T,T,T,T,T,
  T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,
  T,T,T,T,T,D,D,D,D,D,P,P,P,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,P,P,D,D,D,D,T,T,T,T,T,T,
  T,T,T,T,T,D,D,D,D,D,P,P,P,P,D,D,D,D,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,D,D,P,P,P,P,P,D,D,D,T,T,T,T,T,T,
  T,T,T,T,T,T,D,D,D,P,P,P,P,P,P,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,P,P,P,P,P,P,P,D,D,T,T,T,T,T,T,
  T,T,T,T,T,T,D,D,D,P,P,P,P,P,P,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,P,P,P,P,P,P,P,D,D,T,T,T,T,T,T,
  T,T,T,T,T,T,D,D,D,P,P,P,P,P,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,P,P,P,P,P,P,D,D,D,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,D,D,P,P,P,P,D,D,N,N,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,D,D,D,D,D,D,D,P,P,P,P,P,P,D,D,D,D,T,T,T,T,T,
  T,T,T,T,T,T,T,T,D,D,D,D,P,D,D,D,N,N,N,N,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,N,N,N,D,D,D,D,D,D,P,P,P,P,P,P,D,D,D,D,T,T,T,T,T,
  T,T,T,T,T,T,T,D,D,D,D,D,D,D,D,N,N,N,N,N,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,N,N,N,D,D,D,D,D,D,D,D,D,P,P,D,D,D,D,D,T,T,T,T,T,
  T,T,T,T,T,T,D,D,D,D,D,D,D,D,D,N,N,W,N,N,N,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,W,N,N,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,
  T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,N,N,N,N,N,N,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,N,N,N,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,
  T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,N,N,W,N,N,N,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,N,N,N,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,
  T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,N,N,N,N,N,P,N,P,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,W,N,P,N,P,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,
  T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,N,N,N,N,N,N,P,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,N,N,N,P,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,
  T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,N,W,N,N,W,N,N,D,D,D,D,N,N,N,N,D,D,D,D,D,D,N,N,N,N,N,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,
  T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,N,W,W,N,N,N,D,D,D,N,P,P,N,P,N,D,D,D,D,D,D,N,W,N,N,W,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,
  T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,N,D,D,D,D,D,N,P,N,P,P,N,D,D,D,D,D,D,D,N,W,W,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,
  T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,P,N,N,P,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,
  T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,N,N,N,N,D,D,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,
  T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,D,D,D,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,
  T,T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,D,D,N,D,D,N,N,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,D,D,D,D,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,G,G,P,P,P,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,G,G,P,P,P,P,P,D,D,D,D,D,D,D,D,D,D,D,D,D,D,N,N,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,G,G,G,P,P,P,P,P,P,P,D,D,D,D,D,D,D,D,D,D,D,N,N,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,G,G,G,G,G,P,P,P,P,P,P,P,D,D,D,D,D,D,D,D,N,N,N,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,G,G,G,G,G,G,P,P,P,P,P,P,P,P,D,D,D,D,D,N,N,N,N,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,G,G,G,G,G,G,P,P,P,P,P,P,P,P,D,D,D,N,N,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,G,G,G,G,G,G,P,P,P,P,P,P,P,P,P,N,N,N,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,G,G,G,G,G,G,G,P,P,P,P,P,P,P,P,N,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,G,G,G,G,G,G,Y,Y,Y,P,P,P,P,P,P,P,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,G,G,G,G,G,G,Y,Y,Y,P,P,P,P,P,P,P,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,G,G,G,G,G,G,G,G,G,P,P,P,P,P,P,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,G,G,G,G,G,G,G,G,G,G,G,G,G,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,G,G,G,G,G,G,G,G,G,G,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,G,G,G,G,G,G,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,

  /* llchan */
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,M,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,T,T,T,T,T,T,T,T,T,T,M,M,M,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,T,T,T,T,T,T,T,T,M,M,M,M,M,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,M,M,M,M,T,T,T,T,T,M,M,M,M,M,M,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,M,M,M,M,M,O,O,O,O,M,M,M,M,M,M,M,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,M,M,M,M,M,O,O,O,O,M,M,M,M,M,M,M,M,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,M,M,M,M,O,O,O,O,O,M,M,M,M,M,M,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,S,Y,Y,Y,Y,Y,Y,Y,Y,M,M,M,O,O,O,O,O,M,M,M,M,M,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,S,Y,Y,Y,Y,S,Y,Y,Y,M,M,M,M,O,O,O,M,M,M,M,M,M,M,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,Y,Y,Y,Y,Y,S,S,S,S,Y,Y,Y,S,S,S,Y,Y,Y,S,S,S,S,M,M,M,M,M,M,M,M,M,M,M,M,M,M,M,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,Y,S,Y,Y,Y,S,N,N,S,S,Y,Y,S,S,S,Y,Y,S,S,N,N,S,Y,M,M,M,M,M,M,M,T,T,M,M,M,M,M,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,Y,S,S,S,Y,N,W,W,N,S,S,Y,S,S,S,Y,Y,S,N,W,W,N,Y,Y,M,M,M,M,M,M,T,T,T,T,M,M,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,S,S,S,S,S,N,W,W,N,S,S,S,S,S,S,S,S,S,N,W,W,N,S,Y,Y,Y,M,M,M,M,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,S,S,S,S,S,N,N,N,N,S,S,S,S,S,S,S,S,S,N,N,N,N,S,S,Y,Y,M,M,M,M,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,S,S,S,S,S,N,N,W,N,S,S,S,S,S,S,S,S,S,N,W,N,N,S,S,Y,Y,M,M,M,M,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,Y,S,S,S,S,N,N,N,N,S,S,S,S,S,S,S,S,S,N,N,N,N,S,S,S,Y,Y,M,M,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,Y,Y,S,S,S,S,N,N,S,S,S,S,S,S,S,S,S,S,S,N,N,S,S,S,S,Y,Y,T,T,T,T,T,S,S,S,S,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,Y,Y,Y,S,S,S,S,S,S,S,N,S,S,S,N,S,S,S,S,S,S,S,S,S,S,Y,Y,T,T,T,T,S,S,S,S,S,S,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,Y,Y,Y,Y,S,S,S,S,S,S,N,N,N,N,N,S,S,S,S,S,S,S,S,Y,Y,Y,Y,T,T,T,T,S,S,S,S,S,S,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,G,G,G,G,G,T,T,T,T,Y,Y,Y,Y,Y,Y,Y,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,T,T,T,T,Y,T,T,T,T,S,S,S,S,S,S,T,T,T,T,T,T,T,T,
  T,T,T,T,T,G,G,G,G,G,G,G,G,G,T,T,T,T,Y,Y,T,Y,Y,Y,T,Y,S,S,S,S,S,S,S,S,S,S,S,S,S,S,T,T,T,T,T,G,G,G,G,G,S,S,S,S,S,S,T,T,T,T,T,T,T,T,
  T,T,T,G,G,G,G,G,G,G,G,G,G,G,G,G,T,T,T,T,T,T,T,T,T,T,T,S,S,S,S,S,S,S,S,S,T,T,T,T,T,T,T,T,G,G,G,G,G,G,G,S,S,S,S,T,T,T,T,T,T,T,T,T,
  T,T,T,G,G,G,G,G,G,G,G,G,G,G,G,G,G,T,T,T,T,T,T,T,T,T,T,S,S,S,S,S,S,S,S,S,T,T,T,T,T,T,T,G,G,G,G,G,G,G,G,G,S,S,S,G,G,T,T,T,T,T,T,T,
  T,T,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,C,T,T,T,T,T,T,T,T,T,R,S,S,S,S,S,S,S,R,T,T,T,T,T,T,G,G,G,G,G,G,G,G,G,G,S,S,S,G,G,G,T,T,T,T,T,T,
  T,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,C,C,C,T,T,T,T,T,T,R,R,R,S,S,S,S,S,R,R,R,R,R,R,T,G,C,C,G,G,G,G,G,G,G,G,S,S,S,G,G,G,G,T,T,T,T,T,
  T,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,C,C,C,C,T,T,M,M,M,M,R,R,R,R,S,S,R,R,R,M,M,M,M,G,C,C,C,C,G,G,G,G,G,G,G,S,S,S,G,G,G,G,T,T,T,T,T,
  T,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,C,C,C,C,C,M,M,M,M,M,M,R,R,R,R,R,R,R,M,M,M,M,M,M,C,C,C,C,G,G,G,G,G,G,G,S,S,S,G,G,G,G,T,T,T,T,T,
  T,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,S,C,C,C,C,C,M,M,M,M,M,M,M,R,O,O,O,R,M,M,M,M,M,M,M,C,C,C,C,G,G,G,G,G,G,G,S,S,S,G,G,G,G,G,T,T,T,T,
  T,G,G,G,G,G,G,G,G,G,G,G,G,G,G,S,S,C,C,C,C,C,M,M,M,M,M,M,M,O,O,O,O,O,M,M,M,M,M,M,M,C,C,C,S,S,G,G,G,G,G,S,S,S,S,G,G,G,G,G,T,T,T,T,
  T,G,G,G,G,G,G,G,G,G,G,G,G,S,S,S,S,C,C,C,C,C,M,M,M,M,M,M,M,O,O,O,O,O,M,M,M,M,M,M,M,C,C,S,S,S,S,S,G,G,S,S,S,S,S,G,G,G,G,G,T,T,T,T,
  T,G,G,G,G,G,G,G,G,G,G,G,S,S,S,S,S,S,C,C,C,G,M,M,M,M,M,M,M,O,O,O,O,O,M,M,M,M,M,M,M,C,C,S,S,S,S,S,S,S,S,S,S,S,G,G,G,G,G,G,T,T,T,T,
  T,G,G,G,G,G,G,G,G,G,G,S,S,S,S,S,G,G,G,C,G,G,R,M,M,M,M,M,M,O,O,O,O,O,M,M,M,M,M,M,G,G,G,S,S,S,S,S,S,S,S,S,S,S,G,G,G,G,G,G,T,T,T,T,
  T,G,G,G,G,G,G,G,S,S,S,S,S,S,S,S,G,G,G,G,G,G,R,R,R,R,R,M,M,M,O,O,O,M,M,M,M,M,M,G,G,G,G,G,S,S,S,S,S,S,S,S,G,G,G,G,G,G,G,G,T,T,T,T,
  T,G,G,G,G,G,G,S,S,S,S,S,S,S,S,G,G,G,G,G,G,G,R,R,R,R,M,M,M,M,M,R,M,M,M,M,M,R,R,G,G,G,G,G,G,S,S,S,S,S,S,S,G,G,G,G,G,G,G,T,T,T,T,T,
  T,T,G,G,G,G,G,S,S,S,S,S,S,S,S,G,G,G,G,G,G,G,R,R,R,M,M,M,M,M,R,R,R,M,M,M,M,M,R,G,G,G,G,G,G,G,G,S,S,S,S,G,G,G,G,G,G,G,T,T,T,T,T,T,
  T,T,T,G,G,G,G,S,S,S,S,S,S,G,G,G,G,G,G,C,C,C,R,R,R,R,M,M,M,R,R,R,R,R,M,M,M,R,R,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,T,T,T,T,T,T,T,
  T,T,T,T,T,G,G,S,S,S,S,S,G,G,G,G,G,C,C,C,C,C,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,C,C,S,S,S,S,C,C,C,C,C,C,C,C,C,C,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,G,G,G,G,G,G,G,G,G,G,G,G,G,G,G,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,G,G,G,G,G,G,G,G,G,G,C,C,C,C,T,T,T,T,T,T,T,T,T,
  T,T,T,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,C,C,C,C,C,C,C,C,C,C,C,C,C,T,T,T,T,T,T,T,T,
  T,T,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,C,C,C,C,C,C,C,C,C,C,C,C,C,C,T,T,T,T,T,T,T,
  T,T,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,P,P,P,W,W,W,W,P,W,W,W,W,P,W,W,W,W,P,W,W,W,W,P,W,W,W,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,T,T,T,T,T,T,
  T,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,P,P,P,P,P,W,W,P,P,P,W,W,P,P,P,W,W,P,P,P,W,W,P,P,P,W,P,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,T,T,T,T,T,
  T,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,T,T,T,T,
  T,C,C,C,C,C,C,C,C,C,C,C,C,C,C,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,T,T,T,
  T,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,P,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,T,T,
  T,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,R,P,P,R,R,P,P,P,R,R,R,P,P,P,P,R,R,R,P,P,P,R,R,R,P,P,P,R,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,T,T,
  T,C,C,C,C,C,C,C,C,C,C,C,C,C,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,T,T,
  T,T,C,C,C,C,C,C,C,C,C,C,C,C,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,T,T,
  T,T,T,T,C,C,C,C,C,C,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,C,C,C,C,C,C,C,C,C,C,C,C,C,C,C,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,C,C,C,C,C,C,C,C,C,C,C,C,C,C,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,T,T,T,T,C,C,C,C,C,C,C,C,C,C,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,S,S,S,S,T,T,T,T,T,T,T,T,T,T,T,T,T,T,S,S,S,S,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,S,S,S,S,T,T,T,T,T,T,T,T,T,T,T,T,T,T,S,S,S,S,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,S,S,S,S,T,T,T,T,T,T,T,T,T,T,T,T,T,T,S,S,S,S,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,O,S,O,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,O,R,O,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,O,O,O,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,O,O,O,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,O,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,O,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,

  /* boykun */
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,R,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,R,R,R,R,R,R,R,R,R,R,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,R,R,R,R,R,R,R,R,R,R,R,R,R,S,R,S,R,S,R,R,R,R,R,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,R,R,R,R,R,R,R,R,R,R,R,R,S,S,S,S,S,S,S,S,R,R,R,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,R,R,R,R,R,R,R,R,R,R,R,R,C,C,C,C,C,C,C,S,S,R,R,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,R,R,R,R,R,R,R,R,R,R,R,C,C,G,G,G,W,W,C,C,S,S,S,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,R,R,R,R,R,R,R,R,R,C,C,C,G,W,W,W,G,W,W,C,C,S,S,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,R,R,R,R,R,R,R,R,R,C,C,C,G,W,W,W,G,W,W,C,C,S,S,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,R,R,R,R,R,R,R,R,R,C,C,C,G,G,G,G,G,W,W,C,C,C,C,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,R,R,R,R,R,R,R,R,C,C,C,C,G,G,G,G,G,W,W,C,C,C,C,C,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,R,R,R,R,R,R,R,R,R,S,S,S,C,G,G,G,G,G,W,W,C,C,S,S,S,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,R,R,R,R,R,R,R,R,R,S,S,S,S,C,G,G,G,W,W,C,C,S,S,S,S,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,R,S,S,S,S,S,C,C,C,C,C,C,S,S,S,S,S,R,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,R,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,R,N,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,R,R,S,N,S,S,S,N,S,S,S,S,S,S,S,S,S,S,S,B,N,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,R,S,S,S,N,N,N,S,S,S,S,S,S,S,S,S,B,B,B,N,N,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,R,S,S,S,S,S,S,S,S,S,S,S,S,S,B,B,B,B,B,N,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,S,S,S,S,S,S,S,S,S,S,S,S,S,S,B,B,B,B,B,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,S,S,S,S,S,S,S,S,S,S,S,S,S,S,B,B,B,B,B,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,B,B,B,S,S,S,S,B,B,B,B,B,B,B,B,B,B,B,B,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,B,B,B,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,B,B,B,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,B,B,B,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,B,B,N,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,B,B,N,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,B,B,N,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,N,N,N,N,N,N,N,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,N,B,B,B,B,B,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,B,B,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,B,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,B,B,B,B,B,B,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,B,T,T,B,B,B,B,B,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,T,T,T,T,B,B,B,B,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,T,T,T,T,B,B,B,B,B,B,B,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,B,T,T,T,T,T,T,B,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,B,B,B,B,T,T,T,T,T,T,T,T,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,T,T,T,T,T,T,T,T,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,T,T,T,T,T,T,T,T,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,T,T,T,T,T,T,T,T,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,T,T,T,T,T,T,T,T,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,

  /* nssensei */
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,S,S,N,N,S,S,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,S,S,S,N,S,S,S,S,S,S,S,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,S,S,S,S,S,S,S,S,S,S,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,S,S,S,S,S,S,S,S,S,S,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,S,S,S,N,N,N,N,S,S,S,S,S,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,W,W,W,W,N,N,N,N,N,N,S,S,N,W,W,W,W,N,S,S,S,S,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,S,S,N,W,W,W,W,N,N,N,N,N,N,N,S,N,W,W,W,W,N,S,S,S,S,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,S,S,N,N,N,N,N,N,S,S,S,N,N,N,S,N,N,N,N,N,N,S,S,S,S,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,S,S,N,Y,Y,Y,Y,N,S,S,S,S,N,N,S,N,G,G,G,G,N,S,S,S,S,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,S,S,N,Y,Y,Y,Y,N,S,S,S,S,S,S,S,N,G,G,G,G,N,S,S,S,S,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,S,S,S,N,N,N,N,S,S,S,S,S,S,S,S,S,N,N,N,N,S,S,S,S,S,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,S,S,S,S,S,S,S,S,S,S,S,N,S,S,S,S,S,N,S,S,S,S,S,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,S,S,S,S,S,S,S,S,S,S,N,N,N,N,N,N,N,S,S,S,S,S,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,S,S,D,D,S,S,S,S,S,S,D,D,S,S,T,T,T,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,S,D,D,D,S,S,S,S,D,D,D,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,D,D,D,D,D,D,D,D,D,D,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,D,D,D,D,D,D,D,D,D,D,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,D,D,N,N,N,N,N,N,D,D,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,Y,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,Y,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,Y,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,T,T,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,T,T,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,T,T,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,T,T,T,T,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,S,S,S,S,S,S,S,T,T,T,T,T,T,S,S,S,S,S,S,S,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,G,G,N,N,G,G,N,T,T,T,T,T,T,T,S,S,S,S,S,S,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,G,G,G,G,G,G,N,T,T,T,T,T,T,T,S,R,R,N,N,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,G,G,N,N,G,G,N,N,T,T,T,T,T,T,N,R,R,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,N,R,R,N,N,R,R,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,N,N,N,N,N,N,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,

  /* paichan */
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,T,P,P,P,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,P,P,P,P,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,P,P,P,P,P,P,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,P,P,P,P,P,P,P,R,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,P,P,P,P,P,P,R,R,D,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,P,P,P,P,P,R,R,D,D,Y,Y,Y,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,P,P,P,P,R,R,D,D,Y,Y,Y,Y,Y,Y,Y,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,P,P,P,R,R,D,D,Y,Y,Y,Y,Y,Y,Y,Y,Y,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,P,P,R,R,D,D,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,R,R,D,D,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,Y,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,D,D,Y,N,N,N,Y,Y,Y,N,N,N,Y,Y,Y,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,Y,Y,S,S,S,S,Y,S,S,S,S,Y,Y,Y,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,Y,S,N,N,N,S,S,S,N,N,N,S,Y,Y,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,Y,Y,Y,S,N,W,N,S,S,S,N,W,N,S,Y,Y,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,T,T,T,T,Y,Y,Y,S,N,N,N,S,S,S,N,N,N,S,Y,Y,Y,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,B,B,D,D,D,D,T,T,T,Y,Y,S,S,N,P,N,S,S,S,N,P,N,S,S,Y,Y,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,B,B,B,D,G,D,D,T,T,Y,Y,S,S,N,N,N,S,S,S,N,N,N,S,S,Y,Y,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,B,B,D,D,G,G,D,T,T,Y,Y,S,S,S,S,S,S,S,S,S,S,S,S,S,Y,Y,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,G,G,G,D,T,T,Y,Y,S,S,P,P,S,S,S,N,S,S,P,P,S,Y,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,S,D,G,D,D,T,T,Y,Y,S,S,P,P,S,S,S,D,S,S,P,P,S,Y,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,D,D,R,R,D,S,D,D,D,T,T,T,T,T,S,S,S,S,S,S,S,S,S,S,S,S,S,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,D,D,R,R,S,S,D,D,T,T,T,T,T,T,T,S,S,S,S,S,S,S,S,S,S,S,T,T,W,W,W,W,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,D,D,R,D,D,D,D,S,S,T,T,T,T,T,T,T,T,T,S,S,S,S,T,T,T,T,T,W,W,W,W,W,W,W,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,D,D,S,S,S,N,N,N,N,N,N,N,N,N,W,W,W,W,N,N,N,T,W,W,W,W,P,P,W,W,W,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,D,D,D,D,W,S,S,N,N,W,W,W,W,W,W,W,W,W,W,W,W,W,W,N,N,W,W,W,P,P,P,P,W,W,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,W,W,W,W,W,S,N,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,N,W,W,P,P,P,P,W,W,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,W,W,W,W,W,W,N,W,W,W,W,W,W,W,W,W,W,W,W,G,G,W,W,W,W,N,N,W,W,P,P,W,W,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,W,W,W,W,W,W,N,W,W,W,W,W,W,W,W,W,W,W,G,G,G,G,W,W,W,N,N,W,W,W,W,W,W,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,W,W,W,W,W,W,N,W,W,W,W,W,W,W,W,W,W,W,G,G,G,G,W,W,W,N,N,N,W,W,W,W,W,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,W,W,W,W,W,N,N,N,N,W,W,W,W,W,W,W,W,W,G,G,W,W,W,W,N,W,N,W,W,W,W,W,W,W,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,W,W,W,W,G,G,G,G,N,N,W,W,W,R,R,W,W,W,W,W,W,W,W,W,N,W,N,W,Y,Y,Y,Y,W,W,W,W,W,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,W,W,W,G,G,G,G,W,N,W,W,R,R,R,R,W,W,W,W,W,W,W,W,N,W,N,Y,Y,Y,Y,Y,Y,W,W,W,W,W,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,W,W,G,G,R,R,R,N,N,W,R,R,R,R,R,W,W,W,W,W,W,W,N,N,N,Y,D,D,D,Y,Y,W,W,W,W,W,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,W,G,R,R,R,R,W,N,W,W,R,R,R,R,W,W,W,W,W,W,W,W,N,W,D,D,D,D,D,D,W,W,W,W,W,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,W,W,R,R,B,B,W,N,W,W,R,R,W,W,W,W,W,W,W,W,W,W,N,W,D,D,D,D,D,D,W,W,W,W,W,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,W,W,W,W,R,R,B,B,W,N,W,W,W,W,W,W,W,W,B,W,W,W,W,W,N,W,D,D,D,D,D,D,W,W,W,W,W,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,W,W,W,W,W,W,W,B,B,N,N,W,W,W,W,W,W,W,B,B,B,W,W,W,W,N,W,W,D,D,D,D,W,W,W,W,W,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,W,W,W,W,W,W,W,W,W,B,B,N,W,W,W,W,W,W,W,W,B,B,B,W,W,N,N,N,W,W,W,W,W,W,W,W,W,W,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,W,W,W,W,W,W,W,W,W,W,B,W,N,W,W,W,W,W,W,W,B,B,B,B,W,W,N,T,W,W,W,W,W,W,W,W,W,W,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,W,W,W,W,W,W,W,W,W,W,W,W,N,W,W,W,W,W,W,W,B,B,B,W,W,W,N,T,T,W,W,W,W,W,W,W,W,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,W,W,W,W,W,W,W,W,W,W,W,W,N,W,W,W,W,W,W,W,W,W,W,W,W,N,N,T,T,T,W,W,W,W,W,W,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,W,W,W,W,W,W,W,W,W,W,W,N,W,W,W,W,W,W,W,W,W,W,W,W,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,W,W,W,W,W,W,W,W,W,W,N,W,W,N,N,N,W,W,N,N,N,W,W,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,W,W,W,W,W,W,W,W,N,N,N,N,T,N,N,N,N,T,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,W,W,W,W,W,W,W,T,T,T,T,T,S,S,T,T,T,S,S,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,W,W,W,W,W,T,T,T,T,T,T,S,S,T,T,T,S,S,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,T,T,T,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,S,S,T,T,T,S,S,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,S,T,T,T,S,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,C,S,P,P,P,T,P,P,P,S,C,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,C,C,S,C,C,T,C,C,S,C,C,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,C,C,C,T,T,T,C,C,C,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,

  /* ntsensei */
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,R,R,R,R,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,M,P,G,P,R,R,R,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,M,M,P,G,P,R,R,R,P,P,R,R,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,M,P,P,G,P,R,R,R,P,P,R,R,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,M,M,P,G,G,P,R,R,R,P,P,R,R,P,P,P,P,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,M,P,P,G,P,P,R,R,R,P,P,R,R,M,M,M,P,P,P,T,T,T,T,T,T,T,N,N,S,S,S,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,P,P,M,M,P,G,G,P,P,R,R,R,P,P,S,S,M,P,M,M,P,P,P,T,T,T,T,T,T,N,S,S,S,S,S,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,P,P,M,P,P,G,P,P,R,R,R,R,P,P,S,S,M,P,P,M,P,P,P,T,T,T,T,T,T,N,S,S,S,S,S,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,P,P,M,P,P,G,P,P,R,R,R,R,P,P,S,S,M,M,M,M,P,P,P,P,T,T,T,T,T,N,N,S,S,S,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,P,P,M,P,P,G,P,P,R,R,R,R,P,P,S,S,S,S,P,P,P,P,P,P,T,T,T,T,N,S,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,P,P,M,P,P,G,P,P,R,R,R,R,S,S,S,S,S,G,G,G,G,P,P,P,T,T,T,N,S,S,S,S,S,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,P,P,M,S,S,S,S,S,N,N,S,S,S,S,S,S,G,G,P,P,G,G,P,P,T,T,T,P,P,S,S,S,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,P,P,M,S,S,S,S,N,W,W,N,S,S,S,S,N,N,G,G,G,G,P,P,P,T,T,P,P,P,P,S,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,P,P,M,S,S,S,S,N,N,N,N,S,S,S,N,N,S,S,S,S,S,P,P,P,T,P,P,P,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,P,P,M,S,S,S,S,N,M,M,N,S,S,S,N,S,S,S,S,S,S,S,P,P,P,P,P,P,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,P,P,M,S,S,S,S,S,N,N,S,S,N,S,S,S,S,S,S,S,S,S,P,P,P,P,P,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,P,P,M,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,P,P,P,P,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,P,P,T,S,S,S,S,S,S,S,N,S,S,S,N,S,S,S,S,S,S,S,P,P,P,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,S,S,S,S,S,S,S,S,N,N,N,S,S,S,S,S,S,S,S,W,P,P,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,S,W,W,P,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,S,S,S,S,S,S,S,S,S,S,S,S,S,W,W,W,W,W,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,P,P,P,P,P,P,Y,W,W,W,W,W,W,W,W,W,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,P,P,N,P,P,P,P,P,P,N,W,W,W,W,W,W,W,W,W,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,P,P,P,N,P,P,P,P,P,P,N,W,W,W,W,W,W,W,W,W,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,P,P,P,N,P,P,P,P,P,P,N,W,W,W,W,W,W,W,W,W,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,P,P,N,N,N,P,P,P,P,P,P,N,W,W,W,W,W,W,W,W,W,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,P,P,N,T,N,P,P,P,P,P,P,N,W,W,W,W,W,W,W,W,W,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,P,P,N,T,N,P,P,P,P,P,P,N,W,W,W,W,W,W,W,W,W,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,P,P,N,T,N,P,P,P,P,P,P,N,W,W,W,W,W,W,W,W,W,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,P,P,N,N,N,P,P,P,P,P,P,N,W,W,W,W,W,W,W,W,W,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,P,P,P,N,P,P,P,P,P,P,N,W,W,W,W,W,W,W,W,N,N,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,P,N,P,P,P,P,P,P,N,W,W,W,W,W,W,W,N,N,N,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,P,P,P,P,P,P,N,W,W,W,W,W,W,N,N,W,W,P,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,P,P,P,P,P,N,W,W,W,W,W,N,N,W,W,W,W,P,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,P,P,P,P,N,W,W,W,W,N,N,P,W,W,W,W,W,P,P,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,P,P,N,W,W,N,N,N,T,P,P,P,W,W,W,W,P,P,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,N,N,P,P,T,T,P,P,W,W,W,W,W,W,P,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,W,W,W,P,P,P,T,T,T,P,P,W,W,W,W,W,W,W,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,W,W,W,P,P,P,T,T,T,P,P,P,W,W,W,W,W,W,W,W,P,T,T,T,T,T,T,T,T,T,T,N,N,N,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,W,W,W,P,P,P,T,T,T,P,P,P,P,W,W,W,W,W,W,W,S,N,N,N,N,N,N,N,N,N,N,N,W,P,P,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,W,W,W,P,P,P,T,T,T,P,P,P,P,P,W,W,W,W,W,W,S,N,W,W,W,W,W,W,W,N,W,W,W,P,P,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,W,W,W,P,P,P,T,T,T,T,T,T,T,P,P,W,W,W,W,W,S,N,N,W,W,W,W,W,W,N,W,W,P,P,P,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,W,W,W,P,P,P,T,T,T,T,T,T,T,T,P,P,P,P,P,P,S,S,N,N,N,N,N,N,C,C,C,W,P,P,P,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,W,W,W,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,C,W,C,W,P,P,P,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,W,W,W,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,C,C,C,C,C,P,P,P,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,W,W,W,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,C,W,C,P,P,P,P,P,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,W,W,W,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,C,C,C,P,P,P,P,P,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,S,S,S,S,S,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,C,P,P,P,P,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,N,N,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,W,W,W,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,W,W,W,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,W,W,W,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,N,W,W,W,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,C,C,C,C,N,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,C,C,W,C,W,N,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,C,P,C,C,C,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,P,P,P,C,P,P,P,P,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
  T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,T,
};
